
#include <EEPROM.h>
// пины
#define ENC_A 0       // пин энкодера
#define ENC_B 1      // пин энкодера
#define INV_WHEEL 0
//Оси
#define PIN_ACC A1
#define PIN_BRAKE A2
#define PIN_CLUTCH A3
volatile int encCounter = 0;
bool setMode = false;
bool showInfo = false;
uint16_t timerStat;
uint32_t timer; 
int tempMem;
void setup() {
  pinMode(PIN_ACC, INPUT);
  pinMode(PIN_BRAKE, INPUT);
  pinMode(PIN_CLUTCH, INPUT);
  pinMode(ENC_A, INPUT_PULLUP);                           
  pinMode(ENC_B, INPUT_PULLUP);
  attachInterrupt(2, encTick, FALLING);
  Serial.begin(9600);
}

void loop() {
    gamepadTick();
  // put your main code here, to run repeatedly:
if (showInfo)   
    if ((uint16_t)(millis() - timerStat) > 1000)
    {
      timerStat = millis();
      Serial.print("Tick: ");
      Serial.print(encCounter);
      Serial.print("  Clutch: ");
      Serial.print(analogRead(PIN_CLUTCH));
      Serial.print("  Brake: ");
      Serial.print(analogRead(PIN_BRAKE));
      Serial.print("  Acc: ");
      Serial.println(analogRead(PIN_ACC));
  
    }

  String buf;
  if (Serial.available())
  {
    buf = Serial.readString();
    
    if(setMode==true){
      setMode = !setMode;
      Serial.print(F("Число тиков: "));
      EEPROM.put(0,(int)static_cast<float>(encCounter/2.5));
      Serial.print(EEPROM.get(0,tempMem));
      Serial.println(F(" записано в память"));
      buf="";
    }
    else
    {
    if (buf.indexOf("help") != -1) //Включение-выключение вывода данных по осям, силе ОС и времени обработки в Serial. по команде info
    {
        Serial.println(F("Список команд:\r"));
        Serial.println(F(" info - Вкл/выкл вывода данных по осям"));
        Serial.println(F(" showCal - Вывод данных калибровки"));
        Serial.println(F(" Команды калибровки:"));
        Serial.println(F(" setTick - до ввода команды поверните руль влево до упора"));
        Serial.println(F("  minC - сцепление отпущено"));
        Serial.println(F("  maxC - сцепление нажато"));
        Serial.println(F("  minB - тормоз отпущен"));
        Serial.println(F("  maxB - тормоз нажат"));
        Serial.println(F("  minA - газ отпущен"));
        Serial.println(F("  maxA - газ нажат"));
        Serial.println(F("  initMem - сброс памяти"));
        buf = "";
    }
    
    if (buf.indexOf("initMem") != -1){
      EEPROM.put(0, 2400);
      EEPROM.put(20, 1023);
      EEPROM.put(30, 0);
      EEPROM.put(40, 1023);
      EEPROM.put(50, 0);
      EEPROM.put(60, 1023);
      
      Serial.println(F("Инициализация выполнена"));
      buf = "";
    }

      
    if (buf.indexOf("showCal") != -1){
      Serial.println(F("Калибровочные данные педалей"));
      Serial.println("Clutch: " + String(EEPROM.get(10,tempMem)) + " ----- " + String(EEPROM.get(20,tempMem)));
      Serial.println("Brake:  " + String(EEPROM.get(30,tempMem)) + " ----- " + String(EEPROM.get(40,tempMem)));
      Serial.println("Acc:    " + String(EEPROM.get(50,tempMem)) + " ----- " + String(EEPROM.get(60,tempMem)));
      Serial.println("Mode:   " + String(EEPROM.get(0,tempMem)));   
      buf="";
    }
    
    if (buf.indexOf("minA") != -1){
      buf="";
      tempMem=analogRead(PIN_ACC);
      EEPROM.put(50, tempMem);
      Serial.println(F("minA-OK"));     
    }
   if (buf.indexOf("minB") != -1){
      buf="";
      tempMem=analogRead(PIN_BRAKE);
      EEPROM.put(30, tempMem);
      Serial.println(F("minB-OK"));     
    }
     if (buf.indexOf("minC") != -1){
      buf="";
      tempMem=analogRead(PIN_CLUTCH);
      EEPROM.put(10, tempMem);
      Serial.println(F("minC-OK"));     
    }
    if (buf.indexOf("maxA") != -1){
      buf="";
      tempMem=analogRead(PIN_ACC);
      EEPROM.put(60, tempMem);
      Serial.println(F("maxA-OK"));     
    }
   if (buf.indexOf("maxB") != -1){
      buf="";
      tempMem=analogRead(PIN_BRAKE);
      EEPROM.put(40, tempMem);
      Serial.println(F("maxB-OK"));     
    }
     if (buf.indexOf("maxC") != -1){
      buf="";
      tempMem=analogRead(PIN_CLUTCH);
      EEPROM.put(20, tempMem);
      Serial.println(F("maxC-OK"));     
    }
    if (buf.indexOf("info") != -1) //Включение-выключение вывода данных по осям, силе ОС и времени обработки в Serial. по команде info
    {
      showInfo = !showInfo;

     
    }
    }
    if (buf.indexOf("setTick") != -1){   
        setMode = !setMode;
        encCounter=0;
        Serial.println(F("Поверните руль до упора вправо и введите end")); 
        buf="";
    }
  }
}

void encTick(){                                    // функция действие вызываемое прерыванием1
 if (PIND & _BV (PD3)) {   
      encCounter = encCounter + 1;          // по Ч.С.
    } 
    else {
      encCounter = encCounter - 1;          // против Ч.С
    }
}   

void gamepadTick() {
  if (millis() - timer > 10) {
    timer = millis();
  }
}
