/*
MIT License

Copyright (c) 2021 Sulako

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/


#include "axis.h"

void Axis_::setValue(unsigned int rawValue_)
{
  rawValue=rawValue_;
  
  if (autoRange)
  {
      if (rawValue<min)
        min=rawValue;
      if (rawValue>max)
         max=rawValue;
  }

  uint16_t val=constrain(rawValue, min, max);

  if (invert)
    value=65535-map(val, min, max, 0, 65535);
  else
    value= map(val, min, max, 0, 65535);
}
void Axis_::setRange(unsigned int _min, unsigned int _max)
{
    min=_min;
    max=_max;
    autoRange=false;
}
//если одно значение - автокалибровка. Нужно стартовое значение максимума и минимума
void Axis_::setRange(unsigned int value)
{
    min=value;
    max=value;
    autoRange=true;
}
